<template>
  <div class="container">
    <header class="jumbotron">
      <h3>My Profile</h3>
    </header>
    <div class="col-md-12">
      <Form @submit="handleUpdate" :validation-schema="schema">
        <div v-if="!successful">
          <div class="form-group">
            <label for="firstName">First Name</label>
            <Field
              name="firstName"
              type="text"
              value="firstName"
              v-model="firstName"
              class="form-control"
            />
            <ErrorMessage name="firstName" class="error-feedback" />
          </div>
          <div class="form-group">
            <label for="lastName">Last Name</label>
            <Field
              name="lastName"
              v-model="lastName"
              type="text"
              class="form-control"
            />
            <ErrorMessage name="lastName" class="error-feedback" />
          </div>
          <div class="form-group">
            <label for="address">Address</label>
            <Field
              name="address"
              v-model="address"
              type="text"
              class="form-control"
            />
            <ErrorMessage name="address" class="error-feedback" />
          </div>
          <div class="form-group">
            <label for="dob">DOB</label>
            <Field name="dob" v-model="dob" type="text" class="form-control" />
            <ErrorMessage name="dob" class="error-feedback" />
          </div>
          <div class="form-group">
            <label for="phone">Phone</label>
            <Field
              name="phone"
              type="text"
              v-model="phone"
              class="form-control"
            />
            <ErrorMessage name="phone" class="error-feedback" />
          </div>
          <div class="form-group">
            <label for="email">Email</label>
            <Field
              disabled
              name="email"
              type="email"
              v-model="email"
              class="form-control"
            />
            <ErrorMessage name="email" class="error-feedback" />
          </div>

          <div class="form-group">
            <button class="btn btn-primary btn-block" :disabled="loading">
              <span
                v-show="loading"
                class="spinner-border spinner-border-sm"
              ></span>
              Update Profile
            </button>
          </div>
        </div>
      </Form>

      <div
        v-if="message"
        class="alert"
        :class="successful ? 'alert-success' : 'alert-danger'"
      >
        {{ message }}
      </div>
    </div>
  </div>
</template>

<script>
import { Form, Field, ErrorMessage } from "vee-validate";
import * as yup from "yup";
import UserService from "../services/user.service";

export default {
  name: "Profile",
  components: {
    Form,
    Field,
    ErrorMessage,
  },
  data() {
    const schema = yup.object().shape({
      firstName: yup
        .string()
        .required("First name is required!")
        .max(50, "Must be maximum 50 characters!"),
      lastName: yup
        .string()
        .required("Last name is required!")
        .max(50, "Must be maximum 50 characters!"),
      address: yup
        .string()
        .required("Address is required!")
        .max(150, "Must be maximum 150 characters!"),
      dob: yup.date("DOB must be date").required("DOB is required!"),
      phone: yup
        .string()
        .required("Phone is required!")
        .max(15, "Must be maximum 15 characters!"),
      email: yup
        .string()
        .required("Email is required!")
        .email("Email is invalid!")
        .max(50, "Must be maximum 50 characters!"),
    });

    return {
      successful: false,
      loading: false,
      message: "",
      firstName: "",
      lastName: "",
      dob: "",
      address: "",
      phone: "",
      email: "",
      schema,
    };
  },
  onMounted() {
    if (!this.$store.state.auth.user) {
      this.$router.push("/login");
    }
  },
  mounted() {
    UserService.getMe().then(
      (response) => {
        this.firstName = response.data.firstName;
        this.lastName = response.data.firstName;
        this.dob = response.data.dob;
        this.phone = response.data.phone;
        this.address = response.data.address;
        this.email = response.data.email;
      },
      (error) => {
        this.content =
          (error.response &&
            error.response.data &&
            error.response.data.message) ||
          error.message ||
          error.toString();
      }
    );
  },
  methods: {
    handleUpdate(user) {
      this.message = "";
      this.successful = false;
      this.loading = true;

      UserService.updateProfile(
        user.firstName,
        user.lastName,
        user.dob,
        user.address,
        user.phone
      ).then(
        (response) => {
          this.firstName = response.data.firstName;
          this.lastName = response.data.firstName;
          this.dob = response.data.dob;
          this.phone = response.data.phone;
          this.address = response.data.address;
          this.email = response.data.email;

          this.message = response.data.message;
          this.successful = true;
          this.loading = false;
        },
        (error) => {
          this.content =
            (error.response &&
              error.response.data &&
              error.response.data.message) ||
            error.message ||
            error.toString();
        }
      );
    },
  },
};
</script>
